{$if not def HARDWARE_BLIT_H} CONST HARDWARE_BLIT_H=0;

{ *****************************************************************
  ** KickPascal-Include-Datei "hardware/blit.h" zu Kickstart 3.0 **
  ***************************************************************** }

TYPE p_bltnode = ^bltnode;

CONST
 HSIZEBITS = 6;
 VSIZEBITS = (16-HSIZEBITS);
 HSIZEMASK = $3f;
 VSIZEMASK = $3FF;

{$if not def NO_BIG_BLITS}
CONST
 MINBYTESPERROW = 128;
 MAXBYTESPERROW = 4096;
{$endif}
{$if def NO_BIG_BLITS}
CONST
  MAXBYTESPERROW = 128;
{$endif}

CONST
 ABC    = $80;
 ABNC   = $40;
 ANBC   = $20;
 ANBNC  = $10;
 NABC   = $8;
 NABNC  = $4;
 NANBC  = $2;
 NANBNC = $1;

CONST
 A_OR_B  = (ABC or ANBC or NABC or ABNC or ANBNC or NABNC);
 A_OR_C  = (ABC or NABC or ABNC or ANBC or NANBC or ANBNC);
 A_XOR_C = (NABC or ABNC or NANBC or ANBNC);
 A_TO_D  = (ABC or ANBC or ABNC or ANBNC);

CONST
 BC0B_DEST = 8;
 BC0B_SRCC = 9;
 BC0B_SRCB = 10;
 BC0B_SRCA = 11;
 BC0F_DEST = $100;
 BC0F_SRCC = $200;
 BC0F_SRCB = $400;
 BC0F_SRCA = $800;

CONST
 BC1F_DESC = 2;

CONST
 DEST = $100;
 SRCC = $200;
 SRCB = $400;
 SRCA = $800;

CONST
 ASHIFTSHIFT = 12;
 BSHIFTSHIFT = 12;

CONST
 LINEMODE     = $1;
 FILL_OR      = $8;
 FILL_XOR     = $10;
 FILL_CARRYIN = $4;
 ONEDOT       = $2;
 OVFLAG       = $20;
 SIGNFLAG     = $40;
 BLITREVERSE  = $2;

CONST
 SUD = $10;
 SUL = $8;
 AUL = $4;

CONST
 OCTANT8 = 24;
 OCTANT7 = 4;
 OCTANT6 = 12;
 OCTANT5 = 28;
 OCTANT4 = 20;
 OCTANT3 = 8;
 OCTANT2 = 0;
 OCTANT1 = 16;

TYPE bltnode = RECORD
 n         : p_bltnode;
 _function : Ptr;       { "_" ergnzt ! }
 stat      : char;
 blitsize  : Integer;
 beamsync  : Integer;
 cleanup   : Ptr;
END;

CONST
 CLEANUP = $40;
 CLEANME = CLEANUP;

{$endif}
