{$if not def HARDWARE_CIA_H} CONST HARDWARE_CIA_H=0;

{ ****************************************************************
  ** KickPascal-Include-Datei "hardware/cia.h" zu Kickstart 3.0 **
  **************************************************************** }

TYPE p_CIA = ^CIA;

CIA = RECORD
 ciapra    : Byte;
 pad0      : ARRAY[0..$fd] OF Byte;
 ciaprb    : Byte;
 pad1      : ARRAY[0..$fd] OF Byte;
 ciaddra   : Byte;
 pad2      : ARRAY[0..$fd] OF Byte;
 ciaddrb   : Byte;
 pad3      : ARRAY[0..$fd] OF Byte;
 ciatalo   : Byte;
 pad4      : ARRAY[0..$fd] OF Byte;
 ciatahi   : Byte;
 pad5      : ARRAY[0..$fd] OF Byte;
 ciatblo   : Byte;
 pad6      : ARRAY[0..$fd] OF Byte;
 ciatbhi   : Byte;
 pad7      : ARRAY[0..$fd] OF Byte;
 ciatodlow : Byte;
 pad8      : ARRAY[0..$fd] OF Byte;
 ciatodmid : Byte;
 pad9      : ARRAY[0..$fd] OF Byte;
 ciatodhi  : Byte;
 pad10     : ARRAY[0..$fd] OF Byte;
 unusedreg : Byte;
 pad11     : ARRAY[0..$fd] OF Byte;
 ciasdr    : Byte;
 pad12     : ARRAY[0..$fd] OF Byte;
 ciaicr    : Byte;
 pad13     : ARRAY[0..$fd] OF Byte;
 ciacra    : Byte;
 pad14     : ARRAY[0..$fd] OF Byte;
 ciacrb    : Byte;
END;


CONST
 CIAICRB_TA     = 0;
 CIAICRB_TB     = 1;
 CIAICRB_ALRM   = 2;
 CIAICRB_SP     = 3;
 CIAICRB_FLG    = 4;
 CIAICRB_IR     = 7;
 CIAICRB_SETCLR = 7;

CONST
 CIACRAB_START   = 0;
 CIACRAB_PBON    = 1;
 CIACRAB_OUTMODE = 2;
 CIACRAB_RUNMODE = 3;
 CIACRAB_LOAD    = 4;
 CIACRAB_INMODE  = 5;
 CIACRAB_SPMODE  = 6;
 CIACRAB_TODIN   = 7;

CONST
 CIACRBB_START   = 0;
 CIACRBB_PBON    = 1;
 CIACRBB_OUTMODE = 2;
 CIACRBB_RUNMODE = 3;
 CIACRBB_LOAD    = 4;
 CIACRBB_INMODE0 = 5;
 CIACRBB_INMODE1 = 6;
 CIACRBB_ALARM   = 7;

CONST
 CIAICRF_TA     = $1;
 CIAICRF_TB     = $2;
 CIAICRF_ALRM   = $4;
 CIAICRF_SP     = $8;
 CIAICRF_FLG    = $10;
 CIAICRF_IR     = $80;
 CIAICRF_SETCLR = $80;

CONST
 CIACRAF_START   = $1;
 CIACRAF_PBON    = $2;
 CIACRAF_OUTMODE = $4;
 CIACRAF_RUNMODE = $8;
 CIACRAF_LOAD    = $10;
 CIACRAF_INMODE  = $20;
 CIACRAF_SPMODE  = $40;
 CIACRAF_TODIN   = $80;

CONST
 CIACRBF_START   = $1;
 CIACRBF_PBON    = $2;
 CIACRBF_OUTMODE = $4;
 CIACRBF_RUNMODE = $8;
 CIACRBF_LOAD    = $10;
 CIACRBF_INMODE0 = $20;
 CIACRBF_INMODE1 = $40;
 CIACRBF_ALARM   = $80;

CONST
 CIACRBF_IN_PHI2   = 0;
 CIACRBF_IN_CNT    = CIACRBF_INMODE0;
 CIACRBF_IN_TA     = CIACRBF_INMODE1;
 CIACRBF_IN_CNT_TA = (CIACRBF_INMODE0 or CIACRBF_INMODE1);

CONST
 CIAB_GAMEPORT1 = 7;
 CIAB_GAMEPORT0 = 6;
 CIAB_DSKRDY    = 5;
 CIAB_DSKTRACK0 = 4;
 CIAB_DSKPROT   = 3;
 CIAB_DSKCHANGE = 2;
 CIAB_LED       = 1;
 CIAB_OVERLAY   = 0;

CONST
 CIAB_COMDTR   = 7;
 CIAB_COMRTS   = 6;
 CIAB_COMCD    = 5;
 CIAB_COMCTS   = 4;
 CIAB_COMDSR   = 3;
 CIAB_PRTRSEL  = 2;
 CIAB_PRTRPOUT = 1;
 CIAB_PRTRBUSY = 0;

CONST
 CIAB_DSKMOTOR = 7;
 CIAB_DSKSEL3  = 6;
 CIAB_DSKSEL2  = 5;
 CIAB_DSKSEL1  = 4;
 CIAB_DSKSEL0  = 3;
 CIAB_DSKSIDE  = 2;
 CIAB_DSKDIREC = 1;
 CIAB_DSKSTEP  = 0;

CONST
 CIAF_GAMEPORT1 = $80;
 CIAF_GAMEPORT0 = $40;
 CIAF_DSKRDY    = $20;
 CIAF_DSKTRACK0 = $10;
 CIAF_DSKPROT   = $8;
 CIAF_DSKCHANGE = $4;
 CIAF_LED       = $2;
 CIAF_OVERLAY   = $1;

CONST
 CIAF_COMDTR   = $80;
 CIAF_COMRTS   = $40;
 CIAF_COMCD    = $20;
 CIAF_COMCTS   = $10;
 CIAF_COMDSR   = $8;
 CIAF_PRTRSEL  = $4;
 CIAF_PRTRPOUT = $2;
 CIAF_PRTRBUSY = $1;

CONST
 CIAF_DSKMOTOR = $80;
 CIAF_DSKSEL3  = $40;
 CIAF_DSKSEL2  = $20;
 CIAF_DSKSEL1  = $10;
 CIAF_DSKSEL0  = $8;
 CIAF_DSKSIDE  = $4;
 CIAF_DSKDIREC = $2;
 CIAF_DSKSTEP  = $1;

CONST
 Adr_ciaa = $BFE001;
 Adr_ciab = $BFD000;
{$endif}
